%define anolis_release 1
%define abidir %{_prefix}/lib/compatibility/%{name}

Name:           abi-dumper
Version:        1.2
Release:        %{anolis_release}%{?dist}
Summary:        Tool to dump ABI of an ELF object containing DWARF debug info

License:        GPLv2
URL:            http://github.com/lvc/abi-dumper/
Source0:        https://github.com/lvc/%{name}/archive/%{version}.tar.gz#/%{name}-%{version}.tar.gz

BuildArch:      noarch

BuildRequires:  coreutils
BuildRequires:  perl
BuildRequires:  perl-generators
BuildRequires:  perl(Cwd)
BuildRequires:  perl(Data::Dumper)
BuildRequires:  perl(File::Basename)
BuildRequires:  perl(File::Copy)
BuildRequires:  perl(File::Find)
BuildRequires:  perl(File::Path)
BuildRequires:  perl(File::Temp)
BuildRequires:  perl(Getopt::Long)
BuildRequires:  perl(Storable)
BuildRequires:  perl(strict)
BuildRequires:  sed

Requires:       elfutils
Requires:       vtable-dumper >= 1.1
Requires:       perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))

%{?perl_default_filter}

%description
A tool to dump ABI of an ELF object containing DWARF debug info.

The tool is intended to be used with ABI Compliance Checker tool for tracking
ABI changes of a C/C++ library or kernel module.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.


%prep
%autosetup -n %{name}-%{version} -p1


%build
# Nothing to build.


%install
mkdir -p %{buildroot}%{_prefix}
%{__perl} Makefile.pl -install --prefix=%{buildroot}%{_prefix}

chmod 0755 %{buildroot}%{_bindir}/%{name}

mkdir -p %{buildroot}/%{abidir}
pushd %{buildroot}/%{abidir}
for dir in %{_sbindir} %{_bindir} ; do
        for f in $(ls %{buildroot}/$dir) ; do
                full_name=%{buildroot}/$dir/$f
                (file $full_name | grep executable > /dev/null 2>&1 && $full_name --help > $f-option.list > /dev/null 2>&1) || echo "ok"
        done
done

%files
%license LICENSE
%dir %{abidir}
%{_bindir}/%{name}
%{abidir}/%{name}-option.list

%files doc
%doc README.md

%changelog
* Wed Oct 12 2022 happy_orange <songnannan@linux.alibaba.com> - 1.2-1
- Init pacakge from upstream
